﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.85
@EndOfDesignText@
#Region Shared Files
#CustomBuildAction: folders ready, %WINDIR%\System32\Robocopy.exe,"..\..\Shared Files" "..\Files"
'Ctrl + click to sync files: ide://run?file=%WINDIR%\System32\Robocopy.exe&args=..\..\Shared+Files&args=..\Files&FilesSync=True
#End Region

'Ctrl + click to export as zip: ide://run?File=%B4X%\Zipper.jar&Args=Project.zip

Sub Class_Globals
	Private Root As B4XView
	Private xui As XUI
  Private B4XFloatTextField1 As B4XFloatTextField
  Private listOfKeys As List
  Private dummyFocus As Button
	Private busy As Boolean        'to prevent text field from gaining focus automaticallyEnd Sub
End Sub

Public Sub Initialize
	dummyFocus.Initialize("")
'	B4XPages.GetManager.LogEvents = True
End Sub

'This event will be called once, before the page becomes visible.
Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	Root.AddView(dummyFocus, -100, -100, 20, 20)
	Root.LoadLayout("MainPage")
	Dim terms As String = $"
Adventures
Alice
Antipathies
Australia
Carroll
Dinah
DRINK
Latitude
Lewis
Longitude
MARMALADE
ORANGE
Rabbit
White
Wonderland
Zealand
    "$
	listOfKeys.Initialize
	Dim lines() As String = Regex.Split(CRLF, terms)
	For Each s As String In lines
		If s.Trim.Length > 0 Then listOfKeys.Add(s)
	Next
End Sub

Private Sub B4XFloatTextField1_FocusChanged (HasFocus As Boolean)
	If busy = True Then
		busy = False
		Return
	End If
	If HasFocus Then
		Search
	Else
		busy = False
	End If
End Sub

Private Sub B4XFloatTextField1_EnterPressed
	busy = False
	'do other stuff
End Sub

Public Sub Search
	Wait For (displaySearch) Complete (Selection As String)
	If Selection.Length > 0 Then
		busy = True
		B4XFloatTextField1.RequestFocusAndShowKeyboard
		B4XFloatTextField1.Text = Selection
		Sleep(10)
		'B4XFloatTextField1.TextField.SelectAll
		'or
		B4XFloatTextField1.TextField.SetSelection(Selection.Length, 0)
	End If
End Sub

Private Sub displaySearch As ResumableSub
	Dim dia As B4XDialog
	dia.Initialize(Root)
	Dim srch As B4XSearchTemplate
	srch.Initialize
	Dim lst As B4XListTemplate
	lst.Initialize
	Dim TextColor As Int = 0xFF5B5B5B
   
	dia.PutAtTop = True
	dia.BlurBackground = False
	dia.OverlayColor = xui.Color_Transparent
	dia.TitleBarColor = 0xFF0092BB
	dia.TitleBarHeight = 50dip
	dia.BackgroundColor = xui.Color_White
	dia.ButtonsColor = xui.Color_White
	dia.ButtonsTextColor = dia.TitleBarColor
	dia.ButtonsHeight = 40
	dia.BorderWidth = 1
	dia.BorderColor = xui.Color_Black
	dia.BorderCornersRadius = 5dip

	srch.CustomListView1.GetBase.Visible = False
	srch.SearchField.TextField.TextColor = TextColor
	srch.CustomListView1.DefaultTextBackgroundColor = xui.Color_White
	srch.CustomListView1.DefaultTextColor = TextColor
	srch.CustomListView1.sv.ScrollViewInnerPanel.Color = 0xFF9C9C9C
	srch.ItemHightlightColor = 0xFF00C5FF
	srch.SetItems(listOfKeys)
	srch.SearchField.HintText = ""
	srch.SearchField.Update
	srch.Resize(B4XFloatTextField1.mBase.width, 400dip)
	Dim sf As Object = dia.ShowTemplate(srch, "", "", "Cancel")
	Sleep(100)
	dia.Base.Top = B4XFloatTextField1.mBase.top
	dia.Base.Left = B4XFloatTextField1.mBase.left
	srch.CustomListView1.GetBase.Visible = True
	srch.SearchField.text = "?"
	srch.SearchField.TextField.SelectAll
	Wait For (sf) Complete (Result As Int)
	If Result = xui.DialogResponse_Positive Then
		Return srch.SelectedItem
	Else
		Return ""
	End If
End Sub
'You can see the list of page related events in the B4XPagesManager object. The event name is B4XPage.

Private Sub Button1_Click
	xui.MsgboxAsync("Hello world!", "B4X")
End Sub